

//***************************************************************************
//===========================================================================
//---------------------------------------------------------------------------
//
//                    Simple Graphic Library 3D 
//                          << SGL3d >>
//
//                       by Takashi Taniguchi
//                       2001. July. 15 (My Birthday) Version 1.0
//
//---------------------------------------------------------------------------
//===========================================================================
//***************************************************************************
#ifndef __SGL_3D__
#define __SGL_3D__
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glx.h>
#include <GL/glut.h>
#include <math.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "color.h"
#define _MESH 15

/*** Object  ***/


void sgl3d_sphere(    double x,double y,double z,double radius);
void sgl3d_wiresphere(double x,double y,double z,double radius);
void sgl3d_cylinder(double x1,double y1,double z1,
                    double x2,double y2,double z2,
                    double radius);
void sgl3d_cube(double x,double y,double z,double length);
void sgl3d_wirecube(double x, double y, double z, double length);
void sgl3d_box( double x, double y, double z,double length_x,
                double length_y, double length_z );
void sgl3d_wirebox(double x,double y,double z,
                   double length_x,double length_y,double length_z);

void sgl3d_tetrahedron(double x1,double y1,double z1,
		       double x2,double y2,double z2,
		       double x3,double y3,double z3,
		       double x4,double y4,double z4);

void sgl3d_wiretetrahedron(double x1,double y1,double z1,
			   double x2,double y2,double z2,
			   double x3,double y3,double z3,
			   double x4,double y4,double z4);

void sgl3d_line(double x1,double y1,double z1,
                double x2,double y2,double z2, double line_width);

void sgl3d_parallelogram(double x1,double y1,double z1,
			 double x2,double y2,double z2,
			 double x3,double y3,double z3);

void sgl3d_triangle(double x1,double y1,double z1,
                    double x2,double y2,double z2,
                    double x3,double y3,double z3);

/***  Window ***/

void sgl3d_reshape( int width, int height );
void sgl3d_init( void );
void sgl3d_open_window(int height,int width,double length,GLfloat *Colorname);
void sgl3d_change_view_volume(double near, double far);
void sgl3d_change_center_position(double x, double y,double z);
void sgl3d_change_center_xy(double x, double y);
void sgl3d_loop(void func());

/*** Misc  ***/

void sgl3d_color(GLfloat *Colorname);
void sgl3d_color_alpha(GLfloat *Colorname,double alpha);
void sgl3d_display(void);
void sgl3d_frame(void);
void sgl3d_clear(void);

void sgl3d_character( char *charcter, double x, double y, double z,
		      GLfloat *Colorname );

//void sgl3d_character2(char *charcter,double x,double y,GLfloat *Colorname);
//void sgl3d_number( double number, double x, double y, GLfloat *Colorname);

/**************   picture file *****************/
void sgl3d_window2xwd(char *file_name, int number);
void sgl3d_window2ppm(char *file_name, int number);

#endif //__SGL_3D__
